mod login_window;
mod totp_window;
mod application;

use gtk4 as gtk;
use gtk::prelude::*;
use gtk::glib::{self, g_message};

const APP_ID: &str = "im.zander.SimpleLogin";

fn main() -> glib::ExitCode {
    if cfg!(debug_assertions) {
        // allow us to use a test schema for debug runs
        let schema_dir = concat!(env!("OUT_DIR"), "/schemas/");
        g_message!("SimpleLogin", "Using schema dir: \"{}\"", schema_dir);
        std::env::set_var("GSETTINGS_SCHEMA_DIR", schema_dir);
    }
    let app = application::Application::new(APP_ID);
    app.run()
}
