use gtk4 as gtk;
use gtk::{glib, gio, prelude::*, subclass::prelude::*};

mod imp {
    use super::*;
    
    #[derive(Debug, Default, gtk::CompositeTemplate)]
    #[template(file = "data/totp_window.blp")]
    pub struct TotpWindow {

    }

    #[glib::object_subclass]
    impl ObjectSubclass for TotpWindow {
        const NAME: &'static str = "TotpWindow";
        type Type = super::TotpWindow;
        type ParentType = gtk::Window;

        fn class_init(class: &mut Self::Class) {
            class.bind_template();
        }

        fn instance_init(obj: &glib::subclass::InitializingObject<Self>) {
            obj.init_template();
        }
    }

    impl ObjectImpl for TotpWindow {}
    impl WidgetImpl for TotpWindow {}
    impl WindowImpl for TotpWindow {}
}

glib::wrapper! {
    pub struct TotpWindow(ObjectSubclass<imp::TotpWindow>)
        @extends gtk::Widget, gtk::Window,
        @implements gio::ActionMap, gio::ActionGroup;
}

impl TotpWindow {
    pub fn new<P: IsA<gtk::Application>>(app: &P) -> Self {
        glib::Object::builder().property("application", app).build()
    }
}
